/*
 * Turbo Programmer Utilities, turbo-prog-utils, www.bladox.com 
 *
 * Copyright (C) 2004 BLADOX, s.r.o.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define REC	0x10		/* Size of a record. */

char *line, buffer[128];
FILE *infile;

/* Return ASCII hex character for binary value. */
char hex (c)
     int c;
{
  if ((c &= 0x000f) < 10)
    c += '0';
  else
    c += 'A' - 10;
  return ((char) c);
}

/* Put specified number of digits in ASCII hex. */

void puthex (val, digits)
     int val, digits;
{
  if (--digits)
    puthex (val >> 4, digits);
  putchar (hex (val & 0x0f));
}

int main (argc, argv)
     int argc;
     char *argv[];
{
  int c = 1, address = 0, baddress = 0;
  int sum, i, bsum;

  i = 0;
  if (!(infile = fopen (argv[++i], "rb")))
  {
    fprintf (stderr, "Error on open of file %s\n", argv[i]);
    exit (-1);
  }

  while (c != EOF)
  {
    sum = 0;
    line = buffer;
    for (i = 0; i < REC && (c = getc (infile)) != EOF; i++)
    {
      *line++ = hex (c >> 4);
      *line++ = hex (c);
      sum += c;			/* Checksum each character. */
    }
    if (i)
    {
      if (address > 0x0FFFF)
      {
	bsum = 0;
	baddress += 0x1000;
	address = 0;
	putchar (':');
	puthex (2, 2);
	bsum += 2;
	puthex (0, 4);
	bsum += (0 + 0 + 0 + 0);
	puthex (2, 2);
	bsum += 2;
	puthex (baddress, 4);
	bsum += ((baddress & 0xFF00) >> 8);
	bsum += (baddress & 0x00FF);
	puthex (0 - bsum, 2);
	printf ("\n");
      }
      sum += address >> 8;	/* Checksum high address byte. */
      sum += address & 0xff;	/* Checksum low address byte. */
      sum += i;			/* Checksum record byte count. */
      line = buffer;		/* Now output the line! */
      putchar (':');
      puthex (i, 2);		/* Byte count. */
      puthex (address, 4);	/* Do address and increment */
      address += i;		/*    by bytes in record.   */
      puthex (0, 2);		/* Record type.            */
      for (i *= 2; i; i--)	/* Then the actual data.   */
	putchar (*line++);
      puthex (0 - sum, 2);	/* Checksum is 1byte 2's comp. */
      printf ("\n");
    }
  }
  printf (":00000001FF\n");	/* End record. */
}
